#pragma once

#include <memory>
#include <vector>

#include "AudioInterface.h"
#include "AudioDevice.h"

class AudioManager
{

private:

    std::vector<AudioDevicePtr> mAudioDevices;
    AudioInterfaceUPtr mAudioInterface;

public:

    AudioManager();

    ~AudioManager();

    static std::unique_ptr<AudioManager> Create();

    void AddAudioDevice(AudioDevicePtr device);

    std::vector<AudioDevicePtr> GetAudioDevices();

    AudioInterface* GetAudioInterface();
};

using AudioManagerUPtr = std::unique_ptr<AudioManager>;
